import java.awt.*;
import java.util.Calendar;

import javax.swing.JFrame;

@SuppressWarnings("serial")
public class Uhr extends JFrame {
	private static final String TITEL = "Kreisuhr";
	private static final int BREITE = 400, HHE = 300, // Gre des Frames	
		FREQUENZ = 1000,
		RADIUS = 50,
		SEK_LNGE = 5 * RADIUS / 10,
		MIN_LNGE = 6 * RADIUS / 10,
		ST_LNGE = 7 * RADIUS / 10,
		X = BREITE / 2, // Zentrum
		Y = HHE / 2;
	private static final Color HINTERGRUND_FARBE = Color.white, 
		KREIS_FARBE = Color.black,
		STUNDE_FARBE = Color.blue,
		MINUTE_FARBE = Color.green,
		SEKUNDE_FARBE = Color.red;
	public Uhr() {
		new Thread() {
			public void run() {
				Thread.currentThread().setPriority(Thread.NORM_PRIORITY - 1);
				while (true) {
					repaint();
				try {
					Thread.sleep(FREQUENZ); }
				catch (InterruptedException e) {} } }				
		}.start();
		
		setTitle(TITEL);
		setSize(BREITE, HHE);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	
	}
	
	public void update(Graphics g) {
		paint(g); }
	public void paint(Graphics g) {
		g.setColor(HINTERGRUND_FARBE);
		g.fillRect(0, 0, BREITE, HHE);
		g.setColor(KREIS_FARBE);
		g.drawOval((BREITE - 2 * RADIUS) / 2, (HHE - 2 * RADIUS) / 2, 2 * RADIUS, 2 * RADIUS);

		/*
		for (int i = 1; i <= 12; i++) {
			g.setColor(HINTERGRUND_FARBE_2);
			final double arg =  i * 2 * Math.PI / 12,
				sin = RADIUS * Math.sin(arg),
				cos = RADIUS * Math.cos(arg);			
			x2 = (int)(ZENTRUM_X + sin);
			y2 = (int)(ZENTRUM_Y - cos);
			if (i % 3 != 0) {
				x1 = (int)(ZENTRUM_X + 0.9f * sin);
				y1 = (int)(ZENTRUM_Y - 0.9f * cos); }
			else {
				x1 = (int)(ZENTRUM_X + 0.8f * sin);
				y1 = (int)(ZENTRUM_Y - 0.8f * cos); }
			g.drawLine(x1, y1, x2, y2);
			g.setColor(HINTERGRUND_FARBE_3);
			g.drawLine(x1 - 1, y1 - 1, x2 - 1, y2 - 1); }
			*/
		// aktuelle Zeit:
		Calendar kalender = Calendar.getInstance(); 
		final int stunde = kalender.get(Calendar.HOUR) % 12, // zwischen 0 und 12
			minute = kalender.get(Calendar.MINUTE),
			sekunde = kalender.get(Calendar.SECOND);
		final double zweiPi = 2 * Math.PI,
			sek = (stunde + minute / 60.0 + sekunde / 3600.0) * zweiPi / 12,
			min = (minute + sekunde / 60.0) * zweiPi / 60,
			st = sekunde * zweiPi / 60;
		
		g.setColor(SEKUNDE_FARBE);
		g.drawLine(X, Y, (int)(X + SEK_LNGE * Math.sin(sek)), (int)(Y - SEK_LNGE * Math.cos(sek))); // Sekundenzeiger
		
		g.setColor(MINUTE_FARBE);
		g.drawLine(X, Y, (int)(X + MIN_LNGE * Math.sin(min)), (int)(Y - MIN_LNGE * Math.cos(min))); // Minutenzeiger
		
		g.setColor(STUNDE_FARBE);
		g.drawLine(X, Y, (int)(X + ST_LNGE * Math.sin(st)), (int)(Y - ST_LNGE * Math.cos(st))); } // Stundenzeiger 
	public static void main(String[] args) {
		new Uhr();
	}
}
