package genMVC;

import genMVC.IView.Ereignis;
import genMVC.IView.Lauscher;

import java.util.EnumMap;
import java.util.Map;

/**
 * Uhr mit MVC
 * Control
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
public class Control {
	public Control(final IModel model, final IView[] views) {
		Map<Ereignis, Lauscher> lauscher = new EnumMap<Ereignis, Lauscher>(Ereignis.class);
		lauscher.put(Ereignis.EIN, new Lauscher() {
			@Override
			public void aktion() {
				model.start();
				for (IView view : views)
					view.start();
			}
		});
		lauscher.put(Ereignis.AUS, new Lauscher() {
			@Override
			public void aktion() {
				model.stopp();
				for (IView view : views)
					view.stopp();
			}
		});
		lauscher.put(Ereignis.UM, new Lauscher() {
			@Override
			public void aktion() {
				model.umschalten();
			}
		});
		for (IView view : views)
			view.setLauscher(lauscher);

		new Thread() {
			@Override
			public void run() {
				try {
					while (true) {
						Thread.sleep(model.getFrequenz());
						model.tick();
						for (IView view : views)
							view.tick();
					}
				} catch (InterruptedException e) {
				}
			}
		}.start();
		model.start();
	}
}
