package genMVC;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

/**
 * Uhr mit MVC
 * View fr digitale Anzeige
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
@SuppressWarnings("serial")
public class DigitalView extends JFrame implements IView {
	final static String TITEL = "Uhr",
			KNOPF_EIN = "Ein", KNOPF_AUS = "Aus", KNOPF_UM = "Um";
	private final static String DIGITAL = "Digitaluhr: ";	
	private static final int BREITE = 400, HHE = 300; // Gre des Frames:	

	private JTextField anzeige;
	private JButton[] knpfe; // knopfEin, knopfAus, knopfUm;
	private IModel model;	
	public DigitalView(IModel model) {
		this.model = model;
		
		setTitle(TITEL);
		setSize(BREITE, HHE);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
		super.add(new JLabel(DIGITAL));
		anzeige = new JTextField(10);
		anzeige.setEditable(false);
		super.add(anzeige);

		knpfe = new JButton[3];
		knpfe[0] = new JButton(KNOPF_EIN);
		knpfe[1] = new JButton(KNOPF_AUS);
		knpfe[2] = new JButton(KNOPF_UM);
		super.add(knpfe[0]);
		super.add(knpfe[1]);
		super.add(knpfe[2]);		

		this.start();
		pack();		
	}		
	@Override
	public void setLauscher(final Map<Ereignis, Lauscher> lauscherMap) {
		knpfe[0].addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				lauscherMap.get(Ereignis.EIN).aktion();
			}
			
		});
		knpfe[1].addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				lauscherMap.get(Ereignis.AUS).aktion();
			}
			
		});
		knpfe[2].addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				lauscherMap.get(Ereignis.UM).aktion();
			}
			
		});
	}
	@Override
	public void start() {
		knpfe[0].setEnabled(false);
		knpfe[1].setEnabled(true);
	}
	@Override
	public void stopp() {
		knpfe[0].setEnabled(true);
		knpfe[1].setEnabled(false);
	}
	@Override
	public void tick() {
		genMVC.IModel.Uhrzeit uhrzeit = model.getUhrzeit();
        anzeige.setText(String.format("%02d:%02d:%02d", uhrzeit.getStunde(), uhrzeit.getMinute(), uhrzeit.getSekunde()));
	}
}

