package genMVC;
import java.util.Calendar;
/**
 * Uhr mit MVC - Model
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
public class Model implements IModel {
	private static final long FREQUENZ = 1000, // 1 sec
		FREQUENZ_UM = 3000; // 3 sec	

	private boolean uhrAn;
	private Uhrzeit uhrzeit;
	private long frequenz;

	public Model() {
		start();
		tick(); // uhrzeit initialisieren
	}	
	@Override
	public void start() {
		uhrAn = true;
		frequenz = FREQUENZ;
	}
	@Override
	public void stopp() {
		uhrAn = false;
	}
	@Override
	public void tick() {
		if (uhrAn) {
			Calendar kalender = Calendar.getInstance(); 
			uhrzeit = new Uhrzeit(kalender.get(Calendar.HOUR), kalender.get(Calendar.MINUTE), kalender.get(Calendar.SECOND));
		}
	}
	@Override
	public Uhrzeit getUhrzeit() {
		return uhrzeit;
	}
	@Override
	public void umschalten() {
		frequenz = frequenz == FREQUENZ ? FREQUENZ_UM : FREQUENZ;		
	}
	@Override
	public long getFrequenz() {
		return frequenz;
	}
}
