package genObserver;

/**
 * Uhr mit MVC Oberserver - Control
 * Verwaltet und implementiert alle Ereignisse, verffentlich in enum
 * Erhlt im Konstruktor alle Observer, die bei allen Ereignissen benachrichtigt werden.
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 19.4.2012
 */
public class Control extends Observable<Ereignis> {
	public Control(final IModel model) {
		new Thread() {
			@Override
			public void run() {
				try {
					while (true) {
						Thread.sleep(model.getFrequenz());
						notifyObservers(Ereignis.TICK);
					}
				} catch (InterruptedException e) {
				}
			}
		}.start();
	}
	public void start() {
		notifyObservers(Ereignis.INIT);		
	}
}