package genObserver;
import java.util.ArrayList;
import java.util.List;

/**
 * Simple Generic Oberserver implementation
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 04/19/12
 * @param <Event> enum - List of Events for messaging to Observers
 */
public abstract class Observable<Event extends Enum<Event>> {
	private List<Observer<Event>> observerList = new ArrayList<Observer<Event>>();
	/**
	 * remember observer for message passing
	 * @param o Observer to add
	 */
	public void addObserver(Observer<Event> o) {
		observerList.add(o);		
	}
	/**
	 * Message passing
	 */
	public void notifyObservers(Event event) {
		for (Observer<Event> o : observerList)
			o.update(this, event);
	}
}