package mvcObserver;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Observable;
/**
 * Uhr mit MVC Oberserver - Control
 * Verwaltet und implementiert alle Ereignisse, verffentlich in enum
 * Erhlt im Konstruktor alle Observer, die bei allen Ereignissen benachrichtigt werden.
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
public class Control extends Observable {
	public Control(final IModel model) {
		new Thread() {
			@Override
			public void run() {
				try {
					while (true) {
						Thread.sleep(model.getFrequenz());
						setChanged();
						notifyObservers("Tick");
					}
				} catch (InterruptedException e) {
				}
			}
		}.start();
	}
	public void start() {	
		setChanged();
		notifyObservers(new ActionListener() { // Ereignisbehandlungsobjekt bergeben
			@Override
			public void actionPerformed(ActionEvent e) {
				setChanged();
				notifyObservers(e.getActionCommand()); // "Ein", "Aus" oder "Um"		
			}
		});		
	}
}
