package mvcObserver;
import java.util.Calendar;

/**
 * Uhr mit MVC Oberserver
 * Model = Observer, lauscht auf die Eregnisse vom Control
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
public class Model implements IModel { // Observer
	private static final long FREQUENZ = 1000, // 1 sec
		FREQUENZ_UM = 3000; // 3 sec	

		private boolean uhrAn;
		private Uhrzeit uhrzeit;
		private long frequenz;

	/**
	 * Model ist autonom (ohne Parameter)
	 */
	public Model() {
		uhrAn = true;
		frequenz = FREQUENZ;
		tick(); // uhrzeit wird initialisiert
	}
	private void tick() {
		if (uhrAn) {
			Calendar kalender = Calendar.getInstance(); 
			uhrzeit = new Uhrzeit(kalender.get(Calendar.HOUR), kalender.get(Calendar.MINUTE), kalender.get(Calendar.SECOND));
		}
	}
	@Override // IModel
	public Uhrzeit getUhrzeit() {
		return uhrzeit;
	}
	@Override // IModel
	public long getFrequenz() {
		return frequenz;
	}
	/**
	 * Reaktion auf die Ereignisse
	 */
	@Override // Observer
	public void update(java.util.Observable o, Object arg) {
		if (arg.getClass().equals(String.class))
			switch ((String)arg) {
				case "Tick": tick(); break; // uhrzeit wird aktualisiert
				case "Ein": uhrAn = true; break; 
				case "Aus": uhrAn = false; break;
				case "Um": frequenz = frequenz == FREQUENZ ? FREQUENZ_UM : FREQUENZ; break; 
		}
	}
}
