package uhrMVVC;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import java.awt.FlowLayout;
import java.awt.event.ActionListener;
import uhrMVVC.IModel.Uhrzeit;

/**
 * Uhr mit MVVC
 * View fr digitale Anzeige
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */
@SuppressWarnings("serial")
public class DigitalView extends JFrame implements IView {
	final static String DIGITAL = "Digitaluhr: ", TITEL = "Uhr", KNOPF_EIN = "Ein", KNOPF_AUS = "Aus", KNOPF_UM = "Um";
	private static final int BREITE = 400, HHE = 300; // Gre des Frames

	private JTextField textField;
	private JButton[] knpfe; // knopfEin, knopfAus, knopfUm;
	private IModel model;	
	public DigitalView(IModel model) {
		this.model = model;
		
		setTitle(TITEL);
		setSize(BREITE, HHE);
		setVisible(true);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
		super.add(new JLabel(DIGITAL));
		textField = new JTextField(10);
		textField.setEditable(false);
		super.add(textField);

		knpfe = new JButton[3];
		knpfe[0] = new JButton(KNOPF_EIN);
		knpfe[1] = new JButton(KNOPF_AUS);
		knpfe[2] = new JButton(KNOPF_UM);
		for (JButton knopf : knpfe)
			super.add(knopf);

		this.start();
		pack();		
	}
	
	@Override
	public void start() {
		knpfe[0].setEnabled(false);
		knpfe[1].setEnabled(true);
	}
	@Override
	public void stopp() {
		knpfe[0].setEnabled(true);
		knpfe[1].setEnabled(false);
	}
	@Override
	public void tick() {
		Uhrzeit uhrzeit = model.getUhrzeit();
        textField.setText(String.format("%02d:%02d:%02d", uhrzeit.getStunde(), uhrzeit.getMinute(), uhrzeit.getSekunde()));
	}
	// fr das DigitalView-spezifische Control:
	public void setLauscher(ActionListener lauscher) {
		for (JButton knopf : knpfe)
			knopf.addActionListener(lauscher);
	}
}

