package uhrMonolith;

/**
 * Uhr mit Digitalanzeiger
 * @author Prof. Clecon
 * @version 1.0, 08/2011
 * @author Prof. Solymosi, Beuth-Hochschule fr Technik Berlin
 * @version 16.4.2012
 */

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import java.util.Calendar;

@SuppressWarnings("serial")
public class DigitalUhr extends JFrame {
	private static final String TITEL = "Digitaluhr",
		KNOPF_EIN = "Ein", KNOPF_AUS = "Aus", KNOPF_UM = "Um";
	private static final int BREITE = 400, HHE = 300, // Gre des Frames	
		FREQUENZ = 1000, FREQUENZ_UM = 3000; // 1 bzw. 3 sec
	
	private boolean uhrAn = true;
	private int frequenz;
	private JLabel anzeige;
	private JButton[] knpfe; // knopfEin, knopfAus, knopfUm;
	
	DigitalUhr() {
		setTitle(TITEL);
		setSize(BREITE, HHE);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));
		anzeige = new JLabel();
		add(anzeige);

		knpfe = new JButton[3];
		knpfe[0] = new JButton(KNOPF_EIN);
		knpfe[1] = new JButton(KNOPF_AUS);
		knpfe[2] = new JButton(KNOPF_UM);
		for (JButton knopf : knpfe)
			super.add(knopf);
		knpfe[0].setEnabled(false); // "Ein"

		ActionListener lauscher = new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				switch (e.getActionCommand()) { // Beschriftung des Knopfs
				case KNOPF_EIN:
					uhrAn = true;
					break;
				case KNOPF_AUS:
					uhrAn = false;
					break;
				case KNOPF_UM:
					frequenz = frequenz == FREQUENZ ? FREQUENZ_UM : FREQUENZ;
					break;
				}				
				knpfe[0].setEnabled(!uhrAn);
				knpfe[1].setEnabled(uhrAn);
			}
		};
		for (JButton knopf : knpfe)		
			knopf.addActionListener(lauscher);

		tick(); // anzeige mit der Uhrzeit initialisieren
		pack();
		setVisible(true);

		new Thread() {
			@Override
			public void run() {
				try {
					while (true) {
						tick();
						Thread.sleep(frequenz);
					}
				} catch (InterruptedException e) {
				}
			}
		}.start();		
	}
	private void tick() {
		if (uhrAn) {
			Calendar kalender = Calendar.getInstance(); 
			anzeige.setText(String.format("%02d:%02d:%02d", kalender.get(Calendar.HOUR), kalender.get(Calendar.MINUTE), kalender.get(Calendar.SECOND)));
		}
	}
	/**
	 * Test
	 * @param args irrelevant
	 */
	public static void main(String[] args) {
		new DigitalUhr();
	}
}
